#include "input_component.h"
#include <raylib.h>

void InputComponent::BindKey(InputAction action, int key) {
    keyBindings[action] = key;
}

void InputComponent::Update() {
    for (const auto& [action, key] : keyBindings) {
        if (IsKeyDown(key)) {
            if (actionCallbacks.find(action) != actionCallbacks.end()) {
                actionCallbacks[action]();
            }
        }
    }
}

void InputComponent::SetActionCallback(InputAction action, std::function<void()> callback) {
    actionCallbacks[action] = std::move(callback);
}
