//
// Created by illyum on 9/13/2024.
//

#include "FatalHandler.h"
#include <execinfo.h>
#include <cstdlib>
#include <fstream>
#include <iostream>
#include <sstream>

void FatalHandler(const std::string& message) {
    std::ofstream crashFile("crash.log", std::ios::app);
    crashFile << "FATAL ERROR: " << message << std::endl;

    void* callstack[128];
    int frames = backtrace(callstack, 128);
    char** symbols = backtrace_symbols(callstack, frames);

    crashFile << "Stack trace:\n";
    for (int i = 0; i < frames; ++i) {
        crashFile << symbols[i] << std::endl;
    }

    free(symbols);
    crashFile.close();

    std::abort();
}